/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables.records;


import com.flamesgroup.commons.CallRouteConfig;
import com.flamesgroup.commons.SmsRouteConfig;
import com.flamesgroup.storage.jooq.tables.Server;

import java.net.InetAddress;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ServerRecord extends UpdatableRecordImpl<ServerRecord> implements Record8<Long, String, Boolean, Boolean, InetAddress, CallRouteConfig, SmsRouteConfig, Boolean> {

	private static final long serialVersionUID = -1428290829;

	/**
	 * Setter for <code>public.server.id</code>.
	 */
	public ServerRecord setId(Long value) {
		setValue(0, value);
		return this;
	}

	/**
	 * Getter for <code>public.server.id</code>.
	 */
	public Long getId() {
		return (Long) getValue(0);
	}

	/**
	 * Setter for <code>public.server.name</code>.
	 */
	public ServerRecord setName(String value) {
		setValue(1, value);
		return this;
	}

	/**
	 * Getter for <code>public.server.name</code>.
	 */
	public String getName() {
		return (String) getValue(1);
	}

	/**
	 * Setter for <code>public.server.vs_enable</code>.
	 */
	public ServerRecord setVsEnable(Boolean value) {
		setValue(2, value);
		return this;
	}

	/**
	 * Getter for <code>public.server.vs_enable</code>.
	 */
	public Boolean getVsEnable() {
		return (Boolean) getValue(2);
	}

	/**
	 * Setter for <code>public.server.ss_enable</code>.
	 */
	public ServerRecord setSsEnable(Boolean value) {
		setValue(3, value);
		return this;
	}

	/**
	 * Getter for <code>public.server.ss_enable</code>.
	 */
	public Boolean getSsEnable() {
		return (Boolean) getValue(3);
	}

	/**
	 * Setter for <code>public.server.public_address</code>.
	 */
	public ServerRecord setPublicAddress(InetAddress value) {
		setValue(4, value);
		return this;
	}

	/**
	 * Getter for <code>public.server.public_address</code>.
	 */
	public InetAddress getPublicAddress() {
		return (InetAddress) getValue(4);
	}

	/**
	 * Setter for <code>public.server.call_route_config</code>.
	 */
	public ServerRecord setCallRouteConfig(CallRouteConfig value) {
		setValue(5, value);
		return this;
	}

	/**
	 * Getter for <code>public.server.call_route_config</code>.
	 */
	public CallRouteConfig getCallRouteConfig() {
		return (CallRouteConfig) getValue(5);
	}

	/**
	 * Setter for <code>public.server.sms_route_config</code>.
	 */
	public ServerRecord setSmsRouteConfig(SmsRouteConfig value) {
		setValue(6, value);
		return this;
	}

	/**
	 * Getter for <code>public.server.sms_route_config</code>.
	 */
	public SmsRouteConfig getSmsRouteConfig() {
		return (SmsRouteConfig) getValue(6);
	}

	/**
	 * Setter for <code>public.server.audio_capture</code>.
	 */
	public ServerRecord setAudioCapture(Boolean value) {
		setValue(7, value);
		return this;
	}

	/**
	 * Getter for <code>public.server.audio_capture</code>.
	 */
	public Boolean getAudioCapture() {
		return (Boolean) getValue(7);
	}

	// -------------------------------------------------------------------------
	// Primary key information
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Record1<Long> key() {
		return (Record1) super.key();
	}

	// -------------------------------------------------------------------------
	// Record8 type implementation
	// -------------------------------------------------------------------------

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row8<Long, String, Boolean, Boolean, InetAddress, CallRouteConfig, SmsRouteConfig, Boolean> fieldsRow() {
		return (Row8) super.fieldsRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Row8<Long, String, Boolean, Boolean, InetAddress, CallRouteConfig, SmsRouteConfig, Boolean> valuesRow() {
		return (Row8) super.valuesRow();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Long> field1() {
		return Server.SERVER.ID;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<String> field2() {
		return Server.SERVER.NAME;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Boolean> field3() {
		return Server.SERVER.VS_ENABLE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Boolean> field4() {
		return Server.SERVER.SS_ENABLE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<InetAddress> field5() {
		return Server.SERVER.PUBLIC_ADDRESS;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<CallRouteConfig> field6() {
		return Server.SERVER.CALL_ROUTE_CONFIG;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<SmsRouteConfig> field7() {
		return Server.SERVER.SMS_ROUTE_CONFIG;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Field<Boolean> field8() {
		return Server.SERVER.AUDIO_CAPTURE;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Long value1() {
		return getId();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String value2() {
		return getName();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Boolean value3() {
		return getVsEnable();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Boolean value4() {
		return getSsEnable();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public InetAddress value5() {
		return getPublicAddress();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CallRouteConfig value6() {
		return getCallRouteConfig();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public SmsRouteConfig value7() {
		return getSmsRouteConfig();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Boolean value8() {
		return getAudioCapture();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord value1(Long value) {
		setId(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord value2(String value) {
		setName(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord value3(Boolean value) {
		setVsEnable(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord value4(Boolean value) {
		setSsEnable(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord value5(InetAddress value) {
		setPublicAddress(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord value6(CallRouteConfig value) {
		setCallRouteConfig(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord value7(SmsRouteConfig value) {
		setSmsRouteConfig(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord value8(Boolean value) {
		setAudioCapture(value);
		return this;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ServerRecord values(Long value1, String value2, Boolean value3, Boolean value4, InetAddress value5, CallRouteConfig value6, SmsRouteConfig value7, Boolean value8) {
		value1(value1);
		value2(value2);
		value3(value3);
		value4(value4);
		value5(value5);
		value6(value6);
		value7(value7);
		value8(value8);
		return this;
	}

	// -------------------------------------------------------------------------
	// Constructors
	// -------------------------------------------------------------------------

	/**
	 * Create a detached ServerRecord
	 */
	public ServerRecord() {
		super(Server.SERVER);
	}

	/**
	 * Create a detached, initialised ServerRecord
	 */
	public ServerRecord(Long id, String name, Boolean vsEnable, Boolean ssEnable, InetAddress publicAddress, CallRouteConfig callRouteConfig, SmsRouteConfig smsRouteConfig, Boolean audioCapture) {
		super(Server.SERVER);

		setValue(0, id);
		setValue(1, name);
		setValue(2, vsEnable);
		setValue(3, ssEnable);
		setValue(4, publicAddress);
		setValue(5, callRouteConfig);
		setValue(6, smsRouteConfig);
		setValue(7, audioCapture);
	}
}
